#!/usr/bin/perl
#
# Parse::YYLex  pbyacc Ȥäʰץࡣ
# Copyright (c) 2009, Hiroyuki Ohsaki.
# All rights reserved.
#
# $Id: parse.pl,v 1.3 2010/01/26 12:32:20 oosaki Exp $
#

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# ⥸塼θѥ '.' ޤ
use lib '.';

use Carp;
use Data::Dumper;
use Parse::YYLex;
use Parse;
use Smart::Comments;
use diagnostics;
use strict;
use warnings;

our $VERSION = '0.1';

# ʸϻΥ顼
sub yyerror {
    my ($msg, $s) = @_;

    croak "yyerror: $msg " . Dumper($s);
}

# Parse::YYLex Фȡ
my (@tokens) = (
    'LPAREN', '\(',
    'RPAREN', '\)',

    'DIGIT', '[0-9]',

    'PLUS', '\+', 'MINUS', '\-', 'MULT', '\*', 'DIV',
    '/',
    qw(ERROR  .*),
    sub {
        die "can\'t analyze: \"$_[1]\"\n";
    });

# ǥХåΤ˥ȥ졼ͭˤ
Parse::YYLex->trace;

# pbyacc إåեɤ߹
Parse::YYLex->ytab('y.tab.ph');

# ʸϥåפ
Parse::YYLex->skip('\s+');

# ɸϤȡɤ߹
my $lexer = Parse::YYLex->new(@tokens);
$lexer->from(\*STDIN);

# ǥХåͭˤơɸϤʸϤ
my $DEBUG = 1;
my $parser = Parse->new($lexer->getyylex(), \&yyerror, $DEBUG);
$parser->yyparse(\*STDIN);

# ʸϤ줿̤̤˥פ롣
print Dumper($Parse::tree);

# ڤƵŪɾơ̤֤
sub eval_tree {
    my $tree = shift;

    ### $tree
    # ǤʤпʤΤǡΤޤ֤ͤ
    return $tree unless (ref $tree eq 'ARRAY');

    # ʤ黻ʤΤǡɾ֤ͤ
    return eval_tree($tree->[1]) + eval_tree($tree->[2]) if ($tree->[0] eq '+');
    return eval_tree($tree->[1]) - eval_tree($tree->[2]) if ($tree->[0] eq '-');
    return eval_tree($tree->[1]) * eval_tree($tree->[2]) if ($tree->[0] eq '*');
    return eval_tree($tree->[1]) / eval_tree($tree->[2]) if ($tree->[0] eq '/');
    die "Undefined operator $tree->[0]";
}

# ڤɾͤɽ롣
print eval_tree($Parse::tree), "\n";
